open Types;;
open Perm;;
open Internal;;
open Subst;;
open Printer;;

type 'a fconstrs = ('a term * var) list;;
type 'a evconstrs = (('a term * 'a term) list) list;;
type 'a answer =  ('a subst * 'a fconstrs * 'a evconstrs);;
type 'a sc = 'a answer -> unit

val pp_evconstrs : 'a printer -> 'a evconstrs printer;;

val eunify : 'a Util.equal -> 'a term -> 'a term -> 'a sc -> 'a sc;;

exception EUnify 
