
open Absyn;;
open Tcenv;;
open Monad;;

exception TcFail of string;;

type 'a tcm = (sg,tcenv,'a) scmonad;;

val reflect_ty : Var.var list -> ty -> ty list -> ty;;
val check_ty   : ty -> bool -> tyk -> ty tcm;;
val check_term : term -> ty -> term tcm;;
val infer_term : term -> (term * ty) tcm;;
val check_goal : term -> term tcm;;
val check_prog : term -> term tcm;;

